<script setup>
import { onMounted } from 'vue';
import { useISAStore } from '@/stores/useISAStore'
const route = useRoute()
const ISAStore = useISAStore()
const dialog = ref(false)
const study_to_delete = ref("")
const studyName = ref(null)
const showDataLinkWizard = ref(false)
const showImportWizard = ref(false)
const isaObject = ref(null)
const path = ref(null)
const depthDataObjects = ref(0)

onMounted(() => {
    studyName.value.focus()
})

// retrieve investigation data
if(ISAStore.investigations.size == 0) {
    await ISAStore.fetchInvestigations()
}
await ISAStore.fetchStudies(+route.params.iid)

if(! await ISAStore.setCurrentStudy(+route.params.iid, +route.params.sid))
{
    // 404
}

await ISAStore.fetchAssays(+route.params.iid, +route.params.sid)

function activateStudy() {
    ISAStore.currentStudy.status = 'active'
    saveCurrentStudy()
}

function saveCurrentStudy() {
    ISAStore.addUpdatedStudy(+route.params.iid, +route.params.sid)
}

async function deleteCurrentStudy() {
    await ISAStore.deleteCurrentStudy()
    dialog.value = false
    navigateTo('/investigations/'+route.params.iid)
}

async function newAssay() {
    let assay = await ISAStore.createPendingAssay(ISAStore.currentSid.iid, ISAStore.currentSid.sid)
    navigateTo('/investigations/i'+ISAStore.currentSid.iid+'/studies/s'+ISAStore.currentSid.sid+'/assays/'+assay.id)
}

</script>

<template>
    <ImportWizard v-model="showImportWizard" :isaObject="ISAStore.currentStudy" :investigationId="Number(route.params.iid)"/>
    <v-dialog
      v-model="dialog"
      width="500"
    >
      <v-card>
        <v-card-title>Do you really want to delete this study ?</v-card-title>
        <v-card-text>
            <p>By deleting this study all the associated assays, as well as the data links will be deleted.</p>

            <div v-if="ISAStore.currentStudy.name">
                <p class="mt-2">To confirm, type the name of the study :</p>
                <v-text-field v-if= "study_to_delete != ISAStore.currentStudy.name && ISAStore.currentStudy.name"
                            label="Study name"
                            variant="solo"
                            autofocus
                            v-model="study_to_delete"
                ></v-text-field>
                <v-text-field v-else
                            label="Study name"
                            variant="solo"
                            autofocus
                            v-model="study_to_delete"
                            @keyup.enter="deleteCurrentStudy()"
                ></v-text-field>
            </div>
        </v-card-text>
        <v-card-actions>
            <v-btn @click="dialog = false">Cancel</v-btn>
            <v-btn color="error" @click="deleteCurrentStudy()" :disabled="study_to_delete != ISAStore.currentStudy.name && ISAStore.currentStudy.name">Delete the study</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <div class="pa-1 d-flex flex-row">
        <v-breadcrumbs class="pa-0" divider="/">
            <v-breadcrumbs-item :title="ISAStore.investigations.get(+$route.params.iid).name ? ISAStore.investigations.get(+$route.params.iid).name : 'No name'"></v-breadcrumbs-item>
            <v-breadcrumbs-item :title="ISAStore.currentStudy.name ? ISAStore.currentStudy.name : 'No name'" disabled></v-breadcrumbs-item>
        </v-breadcrumbs>
        <v-chip class="mr-auto ma-2" size="small">
            <span v-if="ISAStore.hasPendingModification">Saving...</span>
            <span v-if="! ISAStore.hasPendingModification">Everything saved</span>
        </v-chip>
        <div>
            <v-menu>
                <template v-slot:activator="{ props }">
                    <v-btn icon="mdi-dots-horizontal" variant="plain" size="small" v-bind="props"></v-btn>
                </template>
                <v-list density="compact">
                    <v-list-item title="Delete" @click="study_to_delete = ''; dialog = true">
                        <template v-slot:prepend>
                            <v-icon icon="mdi-trash-can-outline"></v-icon>
                        </template>
                    </v-list-item>
                </v-list>
            </v-menu>
        </div>
    </div>

    <div class="pa-4 pt-0">

        <h1>
            <v-text-field
                ref="studyName"
                v-model="ISAStore.currentStudy.name"
                placeholder="No name"
                variant="plain"
                prepend-inner-icon="mdi-notebook-outline"
                class="isa_name"
                @update:model-value="saveCurrentStudy()">
            </v-text-field>
        </h1>
        <small class="pa-0">Study</small>

        <div v-if="ISAStore.currentStudy.status == 'pending'">
            <div class="mt-4">Choose how to create this study...</div>
            <v-list class="pa-0" density="compact">
                <v-list-item class="pa-0"><v-btn color="primary" size="small" class="mt-2" @click="activateStudy()">Empty study</v-btn></v-list-item>
                <v-list-item class="pa-0"><v-btn color="primary" size="small" class="mt-2" @click="showImportWizard = true">Import from ...</v-btn></v-list-item>
            </v-list>
        </div>

        <v-row v-if="ISAStore.currentStudy.status != 'pending'">
            <v-col>
                <v-textarea
                v-model="ISAStore.currentStudy.description"
                placeholder="No description"
                variant="plain"
                rows="1"
                auto-grow
                @update:model-value="saveCurrentStudy()"
                ></v-textarea>

                <DataLinkList :isaObject="ISAStore.currentStudy" :investigationId="Number(+route.params.iid)"/>

                <v-row align="center">
                    <v-col><h2 class="mt-4">Assays</h2></v-col>
                    <v-col cols="auto">
                        <v-btn
                        size="small"
                        color="primary"
                        @click="newAssay()"
                        >New assay</v-btn
                    ></v-col>
                </v-row>
                <v-table v-if="ISAStore.currentStudy?.assays.size > 0" density="compact" class="mt-2 pointer-cursor">
                    <tbody>
                        <tr
                            v-for="assay in ISAStore.currentStudy?.assays.values()"
                            @click="navigateTo('/investigations/i'+ISAStore.currentSid.iid+'/studies/s'+ISAStore.currentSid.sid+'/assays/'+assay.id)">
                            <td><v-icon icon="mdi-test-tube" size="small"></v-icon>{{ assay.name ? assay.name : 'No name' }}</td>
                        </tr>
                    </tbody>
                </v-table>
                <div v-if="ISAStore.currentStudy?.assays.size == 0" class="text-caption">No assay</div>
            </v-col>
            <v-divider
                    class="mx-4"
                    vertical
                >
            </v-divider>
            <v-col cols="3">
                <h2>Data distribution</h2>
            </v-col>
        </v-row>
    </div>
</template>
